//===================================================================
// aPCI-8201 user application interface
//-------------------------------------------------------------------
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#define APCI8201_SLOT_AUTO	((WORD) ~0U)
#define APCI8201_MAX_SLOTS	16
//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define APCI8201_MAX_MEM	9
#define APCI8201_MAX_IO		20
#define APCI8201_MAX_IRQ	7
#define APCI8201_MAX_DMA	7

typedef struct _APCI8201_RESOURCE {
    DWORD   dwNumMemWindows;					// Not used
    DWORD   dwMemBase       [APCI8201_MAX_MEM];	// Not used
    DWORD   dwMemLength     [APCI8201_MAX_MEM];	// Not used
    DWORD   dwMemAttrib     [APCI8201_MAX_MEM];	// Not used
    DWORD   dwNumIOPorts;						// Num IO ports
    DWORD   dwIOPortBase    [APCI8201_MAX_IO];	// I/O port base
    DWORD   dwIOPortLength  [APCI8201_MAX_IO];	// I/O port length
    DWORD   dwNumIRQs;							// NumIRQs
    DWORD   dwIRQRegisters  [APCI8201_MAX_IRQ];	// IRQ Registers
    DWORD   dwIRQAttrib     [APCI8201_MAX_IRQ];	// IRQ Attrib
	DWORD	dwNumDMAs;							// Not used
    DWORD   dwDMALst        [APCI8201_MAX_DMA];	// Not used
    DWORD   dwDMAAttrib     [APCI8201_MAX_DMA];	// Not used
    DWORD   dwReserved1     [3];				// Not used
} APCI8201_RESOURCE, *PAPCI8201RESOURCE;
//-------------------------------------------------------------------
// G[R[hi1/3/8/12DLLŃZbgj
//-------------------------------------------------------------------
#define APCI8201_SUCCESS				0	// ُȂiIj
#define APCI8201_ERR_SYSTEM				1	// Windows  GetLastError() R[Ă
											// ɃhCo[hĂȂ\܂
#define APCI8201_ERR_NO_DEVICE			2	// gp\ȃfoCX܂
#define APCI8201_ERR_IN_USE				3	// w̃foCX͎gpł
#define APCI8201_ERR_INVALID_SLOT		4	// Ș_\Pbgł
#define APCI8201_ERR_RESOURCE			5	// \[XG[
#define APCI8201_ERR_INVALID_ARGUMENT	6	// p[^s
#define	APCI8201_ERR_NOTINIT			7 	// Ă܂B
#define	APCI8201_ERR_MODE				8 	// GPIB ̃[hG[łB
#define	APCI8201_ERR_TIMEOUT			9 	// ^CAEg܂B
#define	APCI8201_ERR_NOLSN				10	// XiiP[uڑj
#define	APCI8201_ERR_BUSY				11	// s
#define	APCI8201_ERR_ETC				12	// ̑̃G[

//-------------------------------------------------------------------
// GPIB p[^`
//-------------------------------------------------------------------

// GPIBXe[^X擾
#define	STS_IFC			0x0001		// IFC
#define	STS_DCAS		0x0002		// DeviceClear
#define	STS_UNC			0x0004		// Ppoll,TCT etc
#define	STS_ERR			0x0008		// Error
#define	STS_GET			0x0010		// GET
#define	STS_SPAS		0x0020		// Spoll
#define	STS_END			0x0040		// END
#define	STS_REM			0x0100		// Remote
#define	STS_LLO			0x0200		// LLO
#define	STS_TLK			0x0400		// Talker
#define	STS_LSN			0x0800		// Listener
#define	STS_ATN			0x1000		// ATN
#define	STS_SRQ			0x2000		// SRQ
#define	STS_REN			0x4000		// REN

// GPIB֘Ap[^w͈
#define	ADDR_MIN		0			// ŏGPIBڽ
#define	ADDR_MAX		30			// ő    "
#define	TIMEOUT_DEFAULT	2000L		// ѱ̫
#define	TIMEOUT_MAX		60000L		// ѱčől

// }`CbZ[W(GPIBR}h)w
#define	LA_0			0x0020		// Listener Addr
#define	TA_0			0x0040		// Talker Addr
#define	UNL				0x003f		// UNListen
#define	UNT				0x005F		// UNTalk
#define	GTL				0x0001		// Go To Local
#define	SDC				0x0004		// Select Device Clear
#define	GET				0x0008		// Group Execute Trigger
#define	LLO				0x0011		// Local Lock Out
#define	DCL				0x0014		// Device Clear
#define	SPE				0x0018		// Serial Poll Enable
#define	SPD				0x0019		// Serial Poll Disable
#define	PPC				0x0005		// Parallel Poll Config
#define	PPE				0x0060		// Parallel Poll Enable
#define	PPZ				0x0070		// Parallel Poll Disable
#define	PPU				0x0015		// Parallel Poll Unconfig
#define	TCT				0x0009		// Take Control (XXX)

// GPIB샂[hw
#define	MODE_SYSCON		1			// Ѻ۰Ӱ
#define	MODE_TLKLSN		0			// İؽӰ
#define	MODE_SLAVE		0			// ڰӰ
#define	MODE_CON		2			// ۰Ӱ(gps)
#define	MODE_MASTER		2			// ϽӰ(gps)

// f~^[hw
#define	DELIM_CRLF		1			// CR + LF(̫)
#define	DELIM_CR		2			// CR
#define	DELIM_LF		3			// LF
#define	DELIM_NO		0			// NOTHING

// dnh[hw
#define	EOI_ON			1			// t(̫)
#define	EOI_OFF			0			// Ȃ
