//===================================================================
// Apci8201s.c
//-------------------------------------------------------------------
// aPCI-8201
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// Date Jun.1999
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "Apci8201w.h"

#define MAXBUFF	4096	// Mp̃obt@l`w
#define MYADRS 	0		// GPIBAhX
#define PRTADRS	1  	    // GPIBAhX

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


//===================================================================
// C
//===================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
										LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR				szbuf[1024];
	DWORD				dwDLLVer, dwDrvVer;	// DLL, Drivero[W
	BOOL				bResult;			// 
	WORD				wLogSlot;			// foCXi[
	WORD				wGpibAdrs;			// haAhX
	WORD				wGpibMode;			// ha[h
	DWORD				dwFifoSize;			// haobt@TCY
	DWORD				dwTimeout;			// ^CAEgl
	APCI8201_RESOURCE	ri;					// \[X
	BYTE				Buff[MAXBUFF];		// Mp̃obt@
	DWORD				dwDataCnt;			// Mf[^
	WORD				wSrqLine;			// rqpC
	BYTE				bStsByte;			// Xe[^XoCg
	WORD				i;					// [vpϐ
	DWORD				dwSWVal;			// armXCb`li[

	//---------------------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------------------
	if ( Apci8201wDllOpen() == FALSE ) {
		ErrorMessage(APCI8201_SLOT_AUTO);
		return 1;
	}
	ResultMessage("DLL[h܂B");
	//---------------------------------------------------------------------------
	// DLL,VxD̃o[Wԍ擾
	//---------------------------------------------------------------------------
	if ( Apci8201wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE ) {
		ErrorMessage(APCI8201_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("o[Wԍ擾\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------------------
	wLogSlot = APCI8201_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Apci8201wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B
	if ( bResult == FALSE ) {
		ErrorMessage(APCI8201_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("foCX̎gp錾\n\n")
					_T("LogSlot: %2d"), wLogSlot);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// \[X擾
	//---------------------------------------------------------------------------
	if ( Apci8201wGetResource(wLogSlot, &ri) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("\[X擾\n")
					_T("NumPorts   : %2d\n")
					_T("IO Address : %04xH - %04xH\n")
					_T("IRQ        : %2d") ,
					ri.dwIOPortLength[0],ri.dwIOPortBase[0],ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0] );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// armXCb`̒l\
	//---------------------------------------------------------------------------
	if ( FALSE == Apci8201wGetSwitchValue(wLogSlot,&dwSWVal)){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf,	_T("BSN : %xh"), dwSWVal );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// aPCI-8201̏
	//---------------------------------------------------------------------------
	wGpibAdrs = MYADRS;			// ̂haAhX
	wGpibMode = MODE_SYSCON;	// Rg[ɂȂ
  	dwFifoSize = MAXBUFF;		// FIFOobt@TCYw
	if ( Apci8201wInit(wLogSlot,wGpibAdrs,wGpibMode,dwFifoSize) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("aPCI-8201̏\n\n")
					_T("My IB-Address: %2d\n")
					_T("IB-Mode: %d\n")
					_T("FifoSize: %d") , 
					wGpibAdrs,wGpibMode,dwFifoSize );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// GP-IB ̃^CAEgݒ
	//---------------------------------------------------------------------------
	dwTimeout = 3000;	// ^CAEgl=Rb
	if ( Apci8201wSetTime(wLogSlot,dwTimeout) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("GP-IB̃^CAEgݒ\n\n")
					_T("Timeout: %dmSec\n") , dwTimeout);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// f~^Ƃdnhݒ
	//---------------------------------------------------------------------------
	if ( Apci8201wSetEos(wLogSlot,DELIM_CRLF,EOI_ON) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("f~^Ƃdnhݒ\n\n") _T(": CR+LF\n") _T("EOI: On"));
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// heb̑MiRg[pj
	//---------------------------------------------------------------------------
	if ( Apci8201wIfc(wLogSlot) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("heb̑M"));
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// w@ւ̃f[^MiRg[pj
	//---------------------------------------------------------------------------
	wGpibAdrs = PRTADRS;			// XîhaAhX
  	dwDataCnt = 10;					// Mf[^
	for (i=0; i<=9; i++)
		Buff[i] = '0' + i;
	if ( Apci8201wSendDataC(wLogSlot,wGpibAdrs,Buff,dwDataCnt) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("w@ւ̃f[^M"));
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// w@킩̃f[^MiRg[pj
	//---------------------------------------------------------------------------
	wGpibAdrs = PRTADRS;			// g[ĴhaAhX
	dwDataCnt = 50;					// Mf[^
	if ( Apci8201wRecvDataC(wLogSlot,wGpibAdrs,Buff,&dwDataCnt) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	Buff[dwDataCnt] = 0;
	wsprintf(szbuf, _T("w@킩̃f[^M\n\n")
					_T("DataCnt: %d\n")
					_T("Data   : %s") ,
					dwDataCnt,(PCHAR *)&Buff );
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// rqpC̏ԔiRg[pj
	//---------------------------------------------------------------------------
	if ( Apci8201wGetSrqLine(wLogSlot,&wSrqLine) == FALSE ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("rqpC̏Ԕ\n\n")
					_T("SRQline: %d") , wSrqLine);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// VA|[siRg[pj
	//---------------------------------------------------------------------------
	if ( wSrqLine == 1 ) {
		wGpibAdrs = PRTADRS;				// VA|[haAhX
		if ( Apci8201wSpoll(wLogSlot,wGpibAdrs,&bStsByte) == FALSE ) {
			ErrorMessage(wLogSlot);
			return 1;
		}
		wsprintf(szbuf, _T("VA|[s\n\n")
						_T("STS Byte: %x") , bStsByte);
		ResultMessage(szbuf);
	}
	//---------------------------------------------------------------------------
	// foCX̎gpI
	//---------------------------------------------------------------------------
	if ( Apci8201wClose(wLogSlot) == FALSE ) {
		ErrorMessage(APCI8201_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("foCX̎gpI\n\n")
					_T("LogSlot: %2d") ,
					wLogSlot);
	ResultMessage(szbuf);
	//---------------------------------------------------------------------------
	// DLL̃A[h
	//---------------------------------------------------------------------------
  	Apci8201wDllClose();
	return 0;
}
//---------------------------------------------------------------------------
// ʂ\
//---------------------------------------------------------------------------
static void	ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, "aPCI-8201", MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
// G[bZ[W\ďI
//---------------------------------------------------------------------------
static void	ErrorMessage(WORD wLogSlot)
{
	DWORD 	dwRes = Apci8201wGetLastError(wLogSlot);
	TCHAR	szbuf[50];

	switch(dwRes) {
		case APCI8201_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxH") , GetLastError());
			break;

		case APCI8201_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aPCI-8201 error\n\n")
							_T("Error code: %08lxH") , dwRes);
			break;
	}
	MessageBox(NULL, szbuf, "aPCI-8201", MB_OK | MB_ICONSTOP);
	// I
	Apci8201wClose(wLogSlot);
  	Apci8201wDllClose();
}

